# zdnet.tcl v1.1 by domsen <domsen@domsen.org> (c)2oo2
#
# liest die zdnet news aus und gibt sie wieder...
# link der newsline abrufbar, newsposter inklusive 
#
# .zdnet
# .zdnetlink <nr>
# zdnetlimit "" fr unbegrenzt
# zdnetnewspost 1 fr ja, 0 fr nein
#
# iszdnethub legt fest ob der bot newshub ist oder nicht, das
# leaf tcl ist auch auf www.domsen.org verfgbar.
#
# zdnetleafs sind die nicks der leafbots auf denen das leaf tcl
# luft
#
# man htte dieses tcl auch simpler coden knnen durch den
# gebrauch von regusbs und wget, aber das wre zu einfach
# gewesen da man die regexpr-strings aus den php backends
# benutzen knnte - wo bleibt da die herausforderung. wget
# ist auerdem nicht auf allen shells erlaubt, also habe ich
# mich fr lynx entschieden. die tcl http lib wollte ich auch
# nicht benutzen, da ich gerne auf fremden externen code
# vollkommen verzichte :-)

set zdnetchans ""
set year ".2002"
set zdnettrigger ".zdnet"
set zdnetlimit "10"
set zdnetsearch ".zdnetlink"
set zdnetnewspost "1"
set iszdnethub "1"
set zdnetleafs ""

bind msg - $zdnettrigger msg_zdnet
bind pub - $zdnettrigger pub_zdnet
bind msg - $zdnetsearch zmsgsearch
bind pub - $zdnetsearch zpubsearch
bind time - "?0 * * * *" zdnetcheck


proc sendzdnetnews { arg } {
global zdnetleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $zdnetleafs] [string tolower $bot]] != -1)} {
putbot $bot "zdnet: $arg"
}}}




proc zdnetcheck { nick uhost hand chan arg } {
global year zdnetchans zdnetnewspost iszdnethub
set zdhdlfile "zdnet.hdl"
set zdnetalt "none"
if {$zdnetnewspost == 1 } {
if {[file exists $zdhdlfile]} {
putlog "zdnet: suche nach neuer newsline"
set temp [open "zdnet.hdl" r]
set counter 0
set hehe " "
while { [eof $temp] != 1 } {
set zeile [gets $temp]
if { [string first $year $zeile] != "-1" } { incr counter }
if { ($counter == 2 ) && ($zeile != "") && ([string first "]" $zeile] != "-1")} {
set position [string first "]" $zeile]
incr position
set zdnetalt [string range $zeile $position [string length $zeile]]
incr counter 2
}}
close $temp }
exec lynx -preparsed -dump -width=200 http://news.zdnet.de/ > zdnet.hdl
set temp [open "zdnet.hdl" r]
set counter 0
set hehe " "
if {$zdnetalt == "none" } { 
putlog "zdnet: headlinefile created"
return 0 
}
while { [eof $temp] != 1 } {
set zeile "[gets $temp]"
if { [string first $year $zeile] != "-1" } { incr counter }
if { ($counter == 2 ) && ($zeile != "") && ([string first "]" $zeile] != "-1")} {
set position [string first "]" $zeile]
incr position
set zdnetneu [string range $zeile $position [string length $zeile]]
if {$zdnetalt == $zdnetneu} { incr counter 2 }
if {$zdnetalt != $zdnetneu} {
putlog "zdnet: neue newsline"
if { $iszdnethub == "1" } { sendzdnetnews $zdnetneu }
foreach chan [channels] {
if {$zdnetchans == "" } { putserv "privmsg $chan :(neue zdnet newsline) $zdnetneu" }
if {$zdnetchans != "" } {
if {([lsearch -exact [string tolower $zdnetchans] [string tolower $chan]] != -1) || ($zdnetchans == "")} {
putserv "privmsg $chan :(neue zdnet newsline) $zdnetneu"
}}}}}}
close $temp
} 


 }









proc zmsgsearch {nick uhost hand arg } {
global zdnetnewspost year
exec lynx -preparsed -dump -width=200 http://news.zdnet.de/ > zdnet.temp
set counter 0
set newslines 0
set linknr ""
set temp [open "zdnet.temp" r]
while { [eof $temp] != "1" } {
set zeile "[gets $temp]"
if { [string first $year $zeile] != "-1" } {
incr counter }
if { ($counter > "0") && ($counter < "3") && ($zeile != "") && ([string first "]" $zeile] != "-1")} {
incr newslines
if {$newslines == $arg} {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://news.zdnet.de/zdnetde/news/"
}}
if {($linknr != "") && ([string first $linknr $zeile ] != -1)} {
set hyperlink [string range $zeile 6 [string length $zeile]]
putserv "privmsg $nick :$hyperlink"
putlog "zdnet: link search by $nick"
}}
close $temp
}

proc zpubsearch {nick uhost hand chan arg } {
global zdnetnewspost year zdnetchans
if {([lsearch -exact [string tolower $zdnetchans] [string tolower $chan]] != -1) || ($zdnetchans == "")} {
exec lynx -preparsed -dump -width=200 http://news.zdnet.de/ > zdnet.temp
set counter 0
set newslines 0
set linknr ""
set temp [open "zdnet.temp" r]
while { [eof $temp] != "1" } {
set zeile "[gets $temp]"
if { [string first $year $zeile] != "-1" } {
incr counter }
if { ($counter > "0") && ($counter < "3") && ($zeile != "") && ([string first "]" $zeile] != "-1")} {
incr newslines
if {$newslines == $arg} {
set position [string first "]" $zeile]
incr position -2
set linknr "[string range $zeile $position [incr position 1]]. http://news.zdnet.de/zdnetde/news/"
}}
if {($linknr != "") && ([string first $linknr $zeile ] != -1)} {
set hyperlink [string range $zeile 6 [string length $zeile]]
putserv "notice $nick :$hyperlink"
putlog "zdnet: link search by $nick on $chan"
}}
close $temp
}}






proc msg_zdnet { nick uhost hand arg } {
global year zdnetlimit
exec lynx -preparsed -dump -width=200 http://news.zdnet.de/ > zdnet.temp
set newslinenr 0
if {($arg == "") && ($zdnetlimit != "")} {
set counter 0
set temp2 [open "zdnet.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first $year $zeile] != "-1" } {
incr counter }
if { ($counter > "0") && ($counter < "3") && ($zeile != "") && ([string first "]" $zeile] != "-1")} {
set position [string first "]" $zeile]
incr position
set newsline [string range $zeile $position [string length $zeile]]
if {$newslinenr < $zdnetlimit } {
incr newslinenr 
putserv "privmsg $nick :$newslinenr $newsline"
}}}
close $temp2
putlog "zdnet: sent last $zdnetlimit newslines to $nick"
}
if {($arg == "all") || ($zdnetlimit == "")} {
set counter 0
set temp2 [open "zdnet.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first $year $zeile] != "-1" } {
incr counter }
if { ($counter > "0") && ($counter < "3") && ($zeile != "") && ([string first "]" $zeile] != "-1")} {
set position [string first "]" $zeile]
incr position
set newsline [string range $zeile $position [string length $zeile]]
incr newslinenr 
putserv "privmsg $nick :$newslinenr $newsline"
}}
close $temp2
putlog "zdnet: sent all newslines to $nick"
}}




proc pub_zdnet { nick uhost hand chan arg } {
global year zdnetchans zdnetlimit
if {([lsearch -exact [string tolower $zdnetchans] [string tolower $chan]] != -1) || ($zdnetchans == "")} {
exec lynx -preparsed -dump -width=200 http://news.zdnet.de/ > zdnet.temp
set newslinenr 0
if {($arg == "") && ($zdnetlimit != "")} {
set counter 0
set temp2 [open "zdnet.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first $year $zeile] != "-1" } {
incr counter }
if { ($counter > "0") && ($counter < "3") && ($zeile != "") && ([string first "]" $zeile] != "-1")} {
set position [string first "]" $zeile]
incr position
set newsline [string range $zeile $position [string length $zeile]]
if {$newslinenr < $zdnetlimit } {
incr newslinenr 
putserv "notice $nick :$newslinenr $newsline"
}}}
close $temp2
putlog "zdnet: sent last $zdnetlimit newslines to $nick on $chan"
}
if {($arg == "all") || ($zdnetlimit == "")} {
set counter 0
set temp2 [open "zdnet.temp" r]
while { [eof $temp2] != "1" } {
set zeile "[gets $temp2]"
if { [string first $year $zeile] != "-1" } {
incr counter }
if { ($counter > "0") && ($counter < "3") && ($zeile != "") && ([string first "]" $zeile] != "-1")} {
set position [string first "]" $zeile]
incr position
set newsline [string range $zeile $position [string length $zeile]]
incr newslinenr 
putserv "notice $nick :$newslinenr $newsline"
}}
close $temp2
putlog "zdnet: sent all newslines to $nick on $chan"
}}}

putlog "*** zdnet.tcl v1.1 by domsen succesfully loaded"

#[EOF]





